#pragma once

#include <wchar.h>
#include "opencv2/core/core.hpp"

class DirectShowWriter
{
public:
	virtual bool Open(const wchar_t *fileName, const void *compressorConfig, double fps, cv::Size frameSize, int type, bool hasAlpha = false) = 0;
	virtual	void Close(void) = 0;
	virtual bool IsOpened(void) = 0;
	virtual bool Write(const cv::Mat& image) = 0;
	virtual const wchar_t* GetLastErrorString(void) = 0;
	virtual void Destroy(void) = 0;

	__declspec(dllexport) static DirectShowWriter* __cdecl GetInstance(void);
};

